// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIColumn;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a UIComponent that represents a single column of data within a
  parent UISheet component.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ColumnTagDeclaration}.
 */
public class UIColumn
    extends AbstractUIColumn implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Column";

  private org.apache.myfaces.tobago.context.Markup markup;
  private java.lang.String width;
  private java.lang.Boolean sortable;
  private java.lang.String align;
  private org.apache.myfaces.tobago.context.Markup currentMarkup;
  private java.lang.Boolean resizable;
  private java.lang.String label;
  private java.lang.String tip;


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    if (markup != null) {
      return markup;
    }
    ValueExpression ve = getValueExpression("markup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    this.markup = markup;
  }

  /**
  The layout token for this column.
   Allowd layout tokens ('*', '&lt;x>*', '&lt;x>px' or '&lt;x>%').
   Where '*' is equvalent to '1*'.

  */
  public java.lang.String getWidth() {
    if (width != null) {
      return width;
    }
    ValueExpression ve = getValueExpression("width");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setWidth(java.lang.String width) {
    this.width = width;
  }

  /**
  Flag indicating whether or not this column is sortable.
   To make a column sortable the data of the sheet must be one of
   <code>java.util.List</code> or <code>Object[]</code>.
  <br />Default: <code>false</code>
  */
  public boolean isSortable() {
    if (sortable != null) {
      return sortable;
    }
    ValueExpression ve = getValueExpression("sortable");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setSortable(boolean sortable) {
    this.sortable = sortable;
  }

  /**
  Alignment of this column.

  */
  public java.lang.String getAlign() {
    if (align != null) {
      return align;
    }
    ValueExpression ve = getValueExpression("align");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setAlign(java.lang.String align) {
    this.align = align;
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    ValueExpression ve = getValueExpression("currentMarkup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Flag indicating whether or not the width of this column in a sheet is resizable, by the user.
  <br />Default: <code>true</code>
  */
  public boolean isResizable() {
    if (resizable != null) {
      return resizable;
    }
    ValueExpression ve = getValueExpression("resizable");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return true;
  }

  public void setResizable(boolean resizable) {
    this.resizable = resizable;
  }

  /**
  Text value to display as label.
   If text contains an underscore the next character is used as accesskey.

  */
  public java.lang.String getLabel() {
    if (label != null) {
      return label;
    }
    ValueExpression ve = getValueExpression("label");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLabel(java.lang.String label) {
    this.label = label;
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    if (tip != null) {
      return tip;
    }
    ValueExpression ve = getValueExpression("tip");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTip(java.lang.String tip) {
    this.tip = tip;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    markup = (org.apache.myfaces.tobago.context.Markup) values[1];
    width = (java.lang.String) values[2];
    sortable = (java.lang.Boolean) values[3];
    align = (java.lang.String) values[4];
    currentMarkup = (org.apache.myfaces.tobago.context.Markup) values[5];
    resizable = (java.lang.Boolean) values[6];
    label = (java.lang.String) values[7];
    tip = (java.lang.String) values[8];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[9];
    values[0] = super.saveState(context);
    values[1] = markup;
    values[2] = width;
    values[3] = sortable;
    values[4] = align;
    values[5] = currentMarkup;
    values[6] = resizable;
    values[7] = label;
    values[8] = tip;
    return values;
  }


}