// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a hidden input element.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.HiddenTagDeclaration}.
 */
public class UIHidden
    extends UIInput  {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Hidden";

  private java.lang.Boolean readonly;
  private java.lang.Boolean disabled;


  /**
  Flag indicating that this component will prohibit changes by the user.
  <br />Default: <code>false</code>
  */
  public boolean isReadonly() {
    if (readonly != null) {
      return readonly;
    }
    ValueExpression ve = getValueExpression("readonly");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setReadonly(boolean readonly) {
    this.readonly = readonly;
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    if (disabled != null) {
      return disabled;
    }
    ValueExpression ve = getValueExpression("disabled");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    readonly = (java.lang.Boolean) values[1];
    disabled = (java.lang.Boolean) values[2];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[3];
    values[0] = super.saveState(context);
    values[1] = readonly;
    values[2] = disabled;
    return values;
  }


}