// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.internal.taglib;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.UICommand;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/** 
 * JSP Tag class, generated from template {@code tag1.2.stg} with class 
 * {@link org.apache.myfaces.tobago.internal.taglib.component.CommandTagDeclaration}.
 */
public final class CommandTag extends TobagoELTag {
  private static final Logger LOG = LoggerFactory.getLogger(CommandTag.class);
  private javax.el.MethodExpression  actionListener;
  private javax.el.ValueExpression  markup;
  private javax.el.ValueExpression  link;
  private javax.el.ValueExpression  value;
  private javax.el.MethodExpression  action;
  private javax.el.ValueExpression  resource;
  private javax.el.ValueExpression  jsfResource;
  private javax.el.ValueExpression  transition;
  private javax.el.ValueExpression  immediate;
  private javax.el.ValueExpression  renderedPartially;
  private javax.el.ValueExpression  target;
  private javax.el.ValueExpression  onclick;
  private javax.el.ValueExpression  disabled;

  @Override
  public String getComponentType() {
    return UICommand.COMPONENT_TYPE;
  }
  @Override
  public String getRendererType() {
    return "Command";
  }

  @Override
  protected void setProperties(final UIComponent uiComponent) {
    super.setProperties(uiComponent);
    final UICommand component = (UICommand) uiComponent;
    final FacesContext context = FacesContext.getCurrentInstance();
    final Application application = context.getApplication();
    if (actionListener != null) {
      component.addActionListener(new javax.faces.event.MethodExpressionActionListener(actionListener));
    }
    if (markup != null) {
      if (!markup.isLiteralText()) {
        component.setValueExpression("markup", markup);
      } else {
        component.setMarkup(org.apache.myfaces.tobago.context.Markup.valueOf(markup.getExpressionString()));
      }
    }
    if (link != null) {
      component.setValueExpression("link", link);
    }

    if (value != null) {
      component.setValueExpression("value", value);
    }

    if (action != null) {
      component.setActionExpression(action);
    }
    if (resource != null) {
      component.setValueExpression("resource", resource);
    }

    if (jsfResource != null) {
      if (!jsfResource.isLiteralText()) {
        component.setValueExpression("jsfResource", jsfResource);
      } else {
        component.setJsfResource(Boolean.parseBoolean(jsfResource.getExpressionString()));
      }
    }
    if (transition != null) {
      if (!transition.isLiteralText()) {
        component.setValueExpression("transition", transition);
      } else {
        component.setTransition(Boolean.parseBoolean(transition.getExpressionString()));
      }
    }
    if (immediate != null) {
      if (!immediate.isLiteralText()) {
        component.setValueExpression("immediate", immediate);
      } else {
        component.setImmediate(Boolean.parseBoolean(immediate.getExpressionString()));
      }
    }
    if (renderedPartially != null) {
      if (!renderedPartially.isLiteralText()) {
        component.setValueExpression("renderedPartially", renderedPartially);
      } else {
        component.setRenderedPartially(splitList(renderedPartially.getExpressionString()));
      }
    }
    if (target != null) {
      component.setValueExpression("target", target);
    }

    if (onclick != null) {
      component.setValueExpression("onclick", onclick);
    }

    if (disabled != null) {
      if (!disabled.isLiteralText()) {
        component.setValueExpression("disabled", disabled);
      } else {
        component.setDisabled(Boolean.parseBoolean(disabled.getExpressionString()));
      }
    }
  }

  public javax.el.MethodExpression getActionListener() {
    return actionListener;
  }

  public void setActionListener(final javax.el.MethodExpression actionListener) {
    this.actionListener = actionListener;
  }

  public javax.el.ValueExpression getMarkup() {
    return markup;
  }

  public void setMarkup(final javax.el.ValueExpression markup) {
    this.markup = markup;
  }

  public javax.el.ValueExpression getLink() {
    return link;
  }

  public void setLink(final javax.el.ValueExpression link) {
    this.link = link;
  }

  public javax.el.ValueExpression getValue() {
    return value;
  }

  public void setValue(final javax.el.ValueExpression value) {
    this.value = value;
  }

  public javax.el.MethodExpression getAction() {
    return action;
  }

  public void setAction(final javax.el.MethodExpression action) {
    this.action = action;
  }

  public javax.el.ValueExpression getResource() {
    return resource;
  }

  public void setResource(final javax.el.ValueExpression resource) {
    this.resource = resource;
  }

  public javax.el.ValueExpression getJsfResource() {
    return jsfResource;
  }

  public void setJsfResource(final javax.el.ValueExpression jsfResource) {
    this.jsfResource = jsfResource;
  }

  public javax.el.ValueExpression getTransition() {
    return transition;
  }

  public void setTransition(final javax.el.ValueExpression transition) {
    this.transition = transition;
  }

  public javax.el.ValueExpression getImmediate() {
    return immediate;
  }

  public void setImmediate(final javax.el.ValueExpression immediate) {
    this.immediate = immediate;
  }

  public javax.el.ValueExpression getRenderedPartially() {
    return renderedPartially;
  }

  public void setRenderedPartially(final javax.el.ValueExpression renderedPartially) {
    this.renderedPartially = renderedPartially;
  }

  public javax.el.ValueExpression getTarget() {
    return target;
  }

  public void setTarget(final javax.el.ValueExpression target) {
    this.target = target;
  }

  public javax.el.ValueExpression getOnclick() {
    return onclick;
  }

  public void setOnclick(final javax.el.ValueExpression onclick) {
    this.onclick = onclick;
  }

  public javax.el.ValueExpression getDisabled() {
    return disabled;
  }

  public void setDisabled(final javax.el.ValueExpression disabled) {
    this.disabled = disabled;
  }



  @Override
  public void release() {
    super.release();
    actionListener = null;
    markup = null;
    link = null;
    value = null;
    action = null;
    resource = null;
    jsfResource = null;
    transition = null;
    immediate = null;
    renderedPartially = null;
    target = null;
    onclick = null;
    disabled = null;
  }
}